/* nl.h -- defines various data types, partially compatible with
   NUTS 3.x.... */

#ifndef __nl_h




/* Customize these as necessary */

#define NL_SERVICE "talkername"
#define NL_LONG_NAME "\"My Talker Name\""
#define NL_SERVER_TYPE "\"NUTS 2.3.0 (nl+)\""
#ifndef NLPORT
#define NLPORT 6002
#endif


/* You should not need to make changes below this
   point unless you are adding functionality.      */

#define SERV_NAME_LEN 80
#define SITE_NAME_LEN 80
#define VERIFY_LEN 20
#define WORD_LEN 40
/* #define ARR_SIZE 1000 */

struct nl_mailnode {
	char user[(NAME_LEN*2)+5];
	struct nl_mailnode *next;
	int exists;
	};

struct netlink {
	char service[SERV_NAME_LEN+1];
	char longname[ARR_SIZE];
	char password[VERIFY_LEN];
	char login_pass[VERIFY_LEN];
	char local_pass[VERIFY_LEN];
	char service_type[WORD_LEN];
	char site[SITE_NAME_LEN+1];
	/* char verification[VERIFY_LEN+1]; */
	char buff[ARR_SIZE*2];
	char mail_to[WORD_LEN+1];
	char mail_from[WORD_LEN+1];
	int mail_status;
	FILE *mailfile;
	time_t last_recvd;
	int port,socket,type,connected;
	int stage,lastcom,allow,warned,keepalive_cnt;
	int ver_major,ver_minor,ver_patch;
	int nl_ver_major, nl_ver_minor, nl_ver_patch;
	int status, mid_line, buffpos, flags;
	int mesg_user;
/*
	struct user_struct *mesg_user;
	struct room_struct *connect_room;
*/
	char room[NAME_LEN+3];
	char remote_room[NAME_LEN+3];
	struct netlink *prev,*next,*next_in_area;
	struct nl_mailnode *mailnode;
	};

/* Please don't touch unless you're adding functionality */

typedef struct netlink *NL_OBJECT;
#define netlink_object netlink;

NL_OBJECT nl_first,nl_last;
NL_OBJECT create_netlink();


/* Netlink defines */
#define UNCONNECTED 0 
#define INCOMING 1 
#define OUTGOING 2
#define CONNECTED 3

#define NL_VER_MAJOR 1
#define NL_VER_MINOR 0
#define NL_VER_PATCH 0


#define MAILTEMPDIR "datadir"


/* NetLink variables */

struct netlink *nlhead;



#if 0
/* unused fluff from Nuts 3.x */
#define DOWN 0
#define VERIFYING 1
#define UP 2
#define ALL 0
#define IN 1
#define OUT 2
#endif



/* NetLink+ Prototypes */

void link_mail_exists(char *inpstr, int val, struct netlink *nl);
void nl_mailpurge(struct netlink *nl);
void nl_ka_update(struct netlink *nl);
void nl_rstat(struct netlink *nl, char *username);
void nl_act(int user, char *inpstr);
void link_mail_receive(char *inpstr, int val, struct netlink *nl);
void nl_mailsend(struct netlink *nl);
void nl_copy(struct netlink *nl, struct netlink *nl2, int login);
void nl_insert(struct netlink *nl);
void nl_bounce(struct netlink *nl, char *from, char *reason);
void nl_write(struct netlink *netlink, char *str);
void init_connections();
void connect_netlink(int user, char *inpstr);
struct netlink *create_netlink();
int shutdown_netlink(struct netlink *netlink);
int disconnect_netlink(int user, char *inpstr);
void netlink_keepalive(struct netlink *netlink);
int connect_to_site(struct netlink *netlink);
void exec_netcom(struct netlink *netlink, char *inpstr);
void nl_ka_update(struct netlink *nl);
void nl_rstat(struct netlink *nl, char *username);
void nl_act(int user,char *inpstr);
void link_mail_exists(char *inpstr, int val, struct netlink *nl);
void link_mail_receive(char *inpstr, int val, struct netlink *nl);
int nl_mailcat(struct netlink *nl, char *inpstr);
void nl_mailpurge(struct netlink *nl);
void nl_mailsend(struct netlink *nl);
void nl_insert(struct netlink *nl);
void nl_bounce(struct netlink *nl, char *from, char *reason);
int get_netcom_num(char *inpstr);
void nl_command_rstat(int user, char *inpstr);
void nl_destroy(struct netlink *nl);
void nl_parse_flags(struct netlink *nl, char *str);
void nl_msg(struct netlink *nl, char *inpstr);
char *get_login_pass(char *username);

#define __nl_h
#endif

/*** THE END ***/

